/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateDefaultsComponent type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateDefaultsComponent{}

// WhatsAppTemplateDefaultsComponent struct for WhatsAppTemplateDefaultsComponent
type WhatsAppTemplateDefaultsComponent struct {
	Type WhatsAppTemplateComponentType `json:"type"`
	FileId *string `json:"file_id,omitempty"`
	FileName *string `json:"file_name,omitempty"`
	TextParams []string `json:"text_params,omitempty"`
	// Both `ttl` & `expired_url` are usefull only for short links generated when sending template, which means only for URL buttons with `https://slace.me` or `https://dev.slace.me` prefix 
	Buttons []WhatsAppTemplateDefaultsButton `json:"buttons,omitempty"`
	Cards []WhatsAppTemplateDefaultsCard `json:"cards,omitempty"`
}

// NewWhatsAppTemplateDefaultsComponent instantiates a new WhatsAppTemplateDefaultsComponent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateDefaultsComponent(type_ WhatsAppTemplateComponentType) *WhatsAppTemplateDefaultsComponent {
	this := WhatsAppTemplateDefaultsComponent{}
	this.Type = type_
	return &this
}

// NewWhatsAppTemplateDefaultsComponentWithDefaults instantiates a new WhatsAppTemplateDefaultsComponent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateDefaultsComponentWithDefaults() *WhatsAppTemplateDefaultsComponent {
	this := WhatsAppTemplateDefaultsComponent{}
	return &this
}

// GetType returns the Type field value
func (o *WhatsAppTemplateDefaultsComponent) GetType() WhatsAppTemplateComponentType {
	if o == nil {
		var ret WhatsAppTemplateComponentType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsComponent) GetTypeOk() (*WhatsAppTemplateComponentType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *WhatsAppTemplateDefaultsComponent) SetType(v WhatsAppTemplateComponentType) {
	o.Type = v
}

// GetFileId returns the FileId field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsComponent) GetFileId() string {
	if o == nil || IsNil(o.FileId) {
		var ret string
		return ret
	}
	return *o.FileId
}

// GetFileIdOk returns a tuple with the FileId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsComponent) GetFileIdOk() (*string, bool) {
	if o == nil || IsNil(o.FileId) {
		return nil, false
	}
	return o.FileId, true
}

// HasFileId returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsComponent) HasFileId() bool {
	if o != nil && !IsNil(o.FileId) {
		return true
	}

	return false
}

// SetFileId gets a reference to the given string and assigns it to the FileId field.
func (o *WhatsAppTemplateDefaultsComponent) SetFileId(v string) {
	o.FileId = &v
}

// GetFileName returns the FileName field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsComponent) GetFileName() string {
	if o == nil || IsNil(o.FileName) {
		var ret string
		return ret
	}
	return *o.FileName
}

// GetFileNameOk returns a tuple with the FileName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsComponent) GetFileNameOk() (*string, bool) {
	if o == nil || IsNil(o.FileName) {
		return nil, false
	}
	return o.FileName, true
}

// HasFileName returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsComponent) HasFileName() bool {
	if o != nil && !IsNil(o.FileName) {
		return true
	}

	return false
}

// SetFileName gets a reference to the given string and assigns it to the FileName field.
func (o *WhatsAppTemplateDefaultsComponent) SetFileName(v string) {
	o.FileName = &v
}

// GetTextParams returns the TextParams field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsComponent) GetTextParams() []string {
	if o == nil || IsNil(o.TextParams) {
		var ret []string
		return ret
	}
	return o.TextParams
}

// GetTextParamsOk returns a tuple with the TextParams field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsComponent) GetTextParamsOk() ([]string, bool) {
	if o == nil || IsNil(o.TextParams) {
		return nil, false
	}
	return o.TextParams, true
}

// HasTextParams returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsComponent) HasTextParams() bool {
	if o != nil && !IsNil(o.TextParams) {
		return true
	}

	return false
}

// SetTextParams gets a reference to the given []string and assigns it to the TextParams field.
func (o *WhatsAppTemplateDefaultsComponent) SetTextParams(v []string) {
	o.TextParams = v
}

// GetButtons returns the Buttons field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsComponent) GetButtons() []WhatsAppTemplateDefaultsButton {
	if o == nil || IsNil(o.Buttons) {
		var ret []WhatsAppTemplateDefaultsButton
		return ret
	}
	return o.Buttons
}

// GetButtonsOk returns a tuple with the Buttons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsComponent) GetButtonsOk() ([]WhatsAppTemplateDefaultsButton, bool) {
	if o == nil || IsNil(o.Buttons) {
		return nil, false
	}
	return o.Buttons, true
}

// HasButtons returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsComponent) HasButtons() bool {
	if o != nil && !IsNil(o.Buttons) {
		return true
	}

	return false
}

// SetButtons gets a reference to the given []WhatsAppTemplateDefaultsButton and assigns it to the Buttons field.
func (o *WhatsAppTemplateDefaultsComponent) SetButtons(v []WhatsAppTemplateDefaultsButton) {
	o.Buttons = v
}

// GetCards returns the Cards field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsComponent) GetCards() []WhatsAppTemplateDefaultsCard {
	if o == nil || IsNil(o.Cards) {
		var ret []WhatsAppTemplateDefaultsCard
		return ret
	}
	return o.Cards
}

// GetCardsOk returns a tuple with the Cards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsComponent) GetCardsOk() ([]WhatsAppTemplateDefaultsCard, bool) {
	if o == nil || IsNil(o.Cards) {
		return nil, false
	}
	return o.Cards, true
}

// HasCards returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsComponent) HasCards() bool {
	if o != nil && !IsNil(o.Cards) {
		return true
	}

	return false
}

// SetCards gets a reference to the given []WhatsAppTemplateDefaultsCard and assigns it to the Cards field.
func (o *WhatsAppTemplateDefaultsComponent) SetCards(v []WhatsAppTemplateDefaultsCard) {
	o.Cards = v
}

func (o WhatsAppTemplateDefaultsComponent) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateDefaultsComponent) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.FileId) {
		toSerialize["file_id"] = o.FileId
	}
	if !IsNil(o.FileName) {
		toSerialize["file_name"] = o.FileName
	}
	if !IsNil(o.TextParams) {
		toSerialize["text_params"] = o.TextParams
	}
	if !IsNil(o.Buttons) {
		toSerialize["buttons"] = o.Buttons
	}
	if !IsNil(o.Cards) {
		toSerialize["cards"] = o.Cards
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateDefaultsComponent struct {
	value *WhatsAppTemplateDefaultsComponent
	isSet bool
}

func (v NullableWhatsAppTemplateDefaultsComponent) Get() *WhatsAppTemplateDefaultsComponent {
	return v.value
}

func (v *NullableWhatsAppTemplateDefaultsComponent) Set(val *WhatsAppTemplateDefaultsComponent) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateDefaultsComponent) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateDefaultsComponent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateDefaultsComponent(val *WhatsAppTemplateDefaultsComponent) *NullableWhatsAppTemplateDefaultsComponent {
	return &NullableWhatsAppTemplateDefaultsComponent{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateDefaultsComponent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateDefaultsComponent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


